<?xml version="1.0" encoding="iso-8859-1"?>
<!-- $Id: java.box.xsl,v 1.1 2003/04/05 02:27:22 stephens Exp $ -->
<xsl:transform
  xmlns="http://www.w3.org/html"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  version="1.1"
>

<!-- 
#########################################################################
# Primitive data type box/unbox 
#
-->

<xsl:template match="box[@type='boolean']" mode="java.box">
  <xsl:text>new java.lang.Boolean((boolean) </xsl:text><xsl:value-of select="." /><xsl:text>)</xsl:text>
</xsl:template>

<xsl:template match="box[@type='byte']" mode="java.box">
  <xsl:text>new java.lang.Byte((byte) </xsl:text><xsl:value-of select="." /><xsl:text>)</xsl:text>
</xsl:template>

<xsl:template match="box[@type='char']" mode="java.box">
  <xsl:text>new java.lang.Char((char) </xsl:text><xsl:value-of select="." /><xsl:text>)</xsl:text>
</xsl:template>

<xsl:template match="box[@type='short']" mode="java.box">
  <xsl:text>new java.lang.Short((short) </xsl:text><xsl:value-of select="." /><xsl:text>)</xsl:text>
</xsl:template>

<xsl:template match="box[@type='int']" mode="java.box">
  <xsl:text>new java.lang.Integer((int) </xsl:text><xsl:value-of select="." /><xsl:text>)</xsl:text>
</xsl:template>

<xsl:template match="box[@type='long']" mode="java.box">
  <xsl:text>new java.lang.Long((long) </xsl:text><xsl:value-of select="." /><xsl:text>)</xsl:text>
</xsl:template>

<xsl:template match="box[@type='float']" mode="java.box">
  <xsl:text>new java.lang.Float((float) </xsl:text><xsl:value-of select="." /><xsl:text>)</xsl:text>
</xsl:template>

<xsl:template match="box[@type='double']" mode="java.box">
  <xsl:text>new java.lang.Double((double) </xsl:text><xsl:value-of select="." /><xsl:text>)</xsl:text>
</xsl:template>

<xsl:template match="box" mode="java.box">
  <xsl:value-of select="." />
</xsl:template>


<xsl:template name="java.box">
  <xsl:param name="type" select="name(.)" />
  <xsl:param name="value" select="./*" />

  <xsl:variable name="node">
    <xsl:element name="box" namespace="">
      <xsl:attribute name="type" namespace="">
        <xsl:value-of select="$type" />
      </xsl:attribute>
        <xsl:value-of select="$value" />
    </xsl:element>
  </xsl:variable>

<!--
  <xsl:message> java.box type=<xsl:value-of select="$type" /> node=<xsl:copy-of select="$node" />
</xsl:message>
 -->

  <xsl:apply-templates select="$node" mode="java.box" />
</xsl:template>


<!--
#########################################################################
##
##
-->

<xsl:template match="boolean" mode="java.unbox">
  <xsl:text>((java.lang.Boolean) </xsl:text><xsl:value-of select="value" /><xsl:text>).booleanValue()</xsl:text>
</xsl:template>

<xsl:template match="byte" mode="java.unbox">
  <xsl:text>((java.lang.(Byte) </xsl:text><xsl:value-of select="value" /><xsl:text>).byteValue()</xsl:text>
</xsl:template>

<xsl:template match="char" mode="java.unbox">
  <xsl:text>((java.lang.Char) </xsl:text><xsl:value-of select="value" /><xsl:text>).charValue()</xsl:text>
</xsl:template>

<xsl:template match="short" mode="java.unbox">
  <xsl:text>((java.lang.Short) </xsl:text><xsl:value-of select="value" /><xsl:text>).shortValue()</xsl:text>
</xsl:template>

<xsl:template match="int" mode="java.unbox">
  <xsl:text>((java.lang.Integer) </xsl:text><xsl:value-of select="value" /><xsl:text>).intValue()</xsl:text>
</xsl:template>

<xsl:template match="long" mode="java.unbox">
  <xsl:text>((java.lang.Long) </xsl:text><xsl:value-of select="value" /><xsl:text>).longValue()</xsl:text>
</xsl:template>

<xsl:template match="float" mode="java.unbox">
  <xsl:text>((java.lang.Float) </xsl:text><xsl:value-of select="value" /><xsl:text>).floatValue()</xsl:text>
</xsl:template>

<xsl:template match="double" mode="java.unbox">
  <xsl:text>((java.lang.Double) </xsl:text><xsl:value-of select="value" /><xsl:text>).doubleValue()</xsl:text>
</xsl:template>

<xsl:template match="*" mode="java.unbox">
  <xsl:value-of select="value" />
</xsl:template>


<xsl:template name="java.unbox">
  <xsl:param name="type" select="name(.)" />
  <xsl:param name="value" select="./*" />

  <xsl:variable name="node">
    <xsl:element name="{$type}">
      <xsl:value-of select="$name" />
    </xsl:element>
  </xsl:variable>

  <xsl:apply-templates select="$node" mode="java.unbox" />
</xsl:template>



</xsl:transform>

