<?xml version="1.0" encoding="iso-8859-1"?>
<!-- $Id: xmi.TaggedValue.xsl,v 1.1 2003/04/05 02:27:22 stephens Exp $ -->
<xsl:transform
  xmlns="http://www.w3.org/html"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  version="1.1"
>

<!-- *****************************************x*******************************
  XMI uses "xmi.id" as node id.
  -->

<xsl:key name="xmi.id" match="*" use="@xmi.id" />

<!-- 
#########################################################################
#  Returns a inherited tagged value for a given node.
#  Follows containment patterns:
#
#  Attribute|Operation->
#  Class|DataType->
#  Package->
#  Model
  -->

<xsl:template match="Foundation.Core.Attribute|Foundation.Core.Operation" mode="xmi.TaggedValue.inherited">
  <xsl:param name="tag" select="'foo'" />
  <xsl:param name="default" />

<!--
  <xsl:message>tVi node=<xsl:copy-of select="name(.)" /></xsl:message>
  <xsl:message>tVi tag=<xsl:value-of select="$tag" /></xsl:message>
-->

  <xsl:variable name="tv" select="Foundation.Core.ModelElement.taggedValue/Foundation.Extension_Mechanisms.TaggedValue[Foundation.Extension_Mechanisms.TaggedValue.tag=$tag]" />

<!--
  <xsl:message>tVi tv=<xsl:copy-of select="$tv" /></xsl:message>
-->

  <xsl:choose>
    <xsl:when test="$tv">
      <xsl:value-of select="$tv/Foundation.Extension_Mechanisms.TaggedValue.value" />
    </xsl:when>
    <xsl:otherwise>
      <xsl:apply-templates select="key('xmi.id', Foundation.Core.Feature.owner/Foundation.Core.Classifier/@xmi.idref)" mode="xmi.TaggedValue.inherited">
        <xsl:with-param name="tag" select="$tag" />
        <xsl:with-param name="default" select="$default" />
      </xsl:apply-templates>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>


<xsl:template match="Foundation.Core.Class|Foundation.Core.DataType" mode="xmi.TaggedValue.inherited">
  <xsl:param name="tag" select="'foo'" />
  <xsl:param name="default" />

<!--
  <xsl:message>tVi node=<xsl:copy-of select="name(.)" /></xsl:message>
  <xsl:message>tVi tag=<xsl:value-of select="$tag" /></xsl:message>
-->

  <xsl:variable name="tv" select="Foundation.Core.ModelElement.taggedValue/Foundation.Extension_Mechanisms.TaggedValue[Foundation.Extension_Mechanisms.TaggedValue.tag=$tag]" />

<!--
  <xsl:message>tVi tv=<xsl:copy-of select="$tv" /></xsl:message>
-->
  <xsl:choose>
    <xsl:when test="$tv">
      <xsl:value-of select="$tv/Foundation.Extension_Mechanisms.TaggedValue.value" />
    </xsl:when>
    <xsl:otherwise>
      <xsl:apply-templates select="key('xmi.id', Foundation.Core.ModelElement.namespace/Foundation.Core.Namespace/@xmi.idref)" mode="xmi.TaggedValue.inherited">
        <xsl:with-param name="tag" select="$tag" />
        <xsl:with-param name="default" select="$default" />
      </xsl:apply-templates>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>


<xsl:template match="Model_Management.Package" mode="xmi.TaggedValue.inherited">
  <xsl:param name="tag" select="'foo'" />
  <xsl:param name="default" />

<!--
  <xsl:message>tVi node=<xsl:copy-of select="name(.)" /></xsl:message>
  <xsl:message>tVi tag=<xsl:value-of select="$tag" /></xsl:message>
-->

  <xsl:variable name="tv" select="Foundation.Core.ModelElement.taggedValue/Foundation.Extension_Mechanisms.TaggedValue[Foundation.Extension_Mechanisms.TaggedValue.tag=$tag]" />

<!--
  <xsl:message>tVi tv=<xsl:copy-of select="$tv" /></xsl:message>
-->

  <xsl:choose>
    <xsl:when test="$tv">
      <xsl:value-of select="$tv/Foundation.Extension_Mechanisms.TaggedValue.value" />
    </xsl:when>
    <xsl:otherwise>
      <xsl:apply-templates select="key('xmi.id', Foundation.Core.ModelElement.namespace/Foundation.Core.Namespace/@xmi.idref)" mode="xmi.TaggedValue.inherited">
        <xsl:with-param name="tag" select="$tag" />
        <xsl:with-param name="default" select="$default" />
      </xsl:apply-templates>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>


<xsl:template match="Model_Management.Model" mode="xmi.TaggedValue.inherited">
  <xsl:param name="tag" select="'foo'" />
  <xsl:param name="default" />

<!--
  <xsl:message>tVi node=<xsl:copy-of select="name(.)" /></xsl:message>
  <xsl:message>tVi tag=<xsl:value-of select="$tag" /></xsl:message>
-->

  <xsl:variable name="tv" select="Foundation.Core.ModelElement.taggedValue/Foundation.Extension_Mechanisms.TaggedValue[Foundation.Extension_Mechanisms.TaggedValue.tag=$tag]" />

<!--
  <xsl:message>tVi tv=<xsl:copy-of select="$tv" /></xsl:message>
-->

  <xsl:choose>
    <xsl:when test="$tv">
      <xsl:value-of select="$tv/Foundation.Extension_Mechanisms.TaggedValue.value" />
    </xsl:when>
    <!-- NOTE: this is where default gets tried. -->
    <xsl:otherwise><xsl:value-of select="$default"/></xsl:otherwise>
  </xsl:choose>
  
</xsl:template>


<!--
####################################################################################
-->

<xsl:template match="*" mode="xmi.TaggedValue.inherited">
</xsl:template>


<xsl:template name="xmi.TaggedValue.inherited">
  <xsl:param name="node" select="." />
  <xsl:param name="tag" />
  <xsl:param name="default" />

<!--
  <xsl:message>tVi node=<xsl:copy-of select="name($node)" /></xsl:message>
  <xsl:message>tVi tag=<xsl:value-of select="$tag" /></xsl:message>
-->

  <xsl:apply-templates select="$node" mode="xmi.TaggedValue.inherited">
    <xsl:with-param name="tag" select="$tag" />
    <xsl:with-param name="default" select="$default" />
  </xsl:apply-templates>

</xsl:template>


<xsl:template name="xmi.TaggedValue.inherited.true">
  <xsl:param name="node" select="." />
  <xsl:param name="tag" />

  <xsl:variable name="v">
    <xsl:call-template name="xmi.TaggedValue.inherited">
      <xsl:with-param name="node" select="$node" />
      <xsl:with-param name="tag" select="$tag" />
    </xsl:call-template>
  </xsl:variable>

  <xsl:variable name="value" select="normalize-space($v)" />

  <xsl:choose>
    <xsl:when test="$value != '' and $value != 'false'"><xsl:value-of select="'true'" /></xsl:when>
    <xsl:otherwise></xsl:otherwise>
  </xsl:choose>

<!--
  <xsl:message><xsl:value-of select="name($node)"/>.<xsl:value-of select="$tag"/> = <xsl:value-of select="$result" />  <xsl:copy-of select="$result" /> </xsl:message>
  <xsl:value-of select="$result" />
-->

</xsl:template>


<xsl:template name="xmi.TaggedValue.inherited.true.or">
  <xsl:param name="nodes" select="." />
  <xsl:param name="tag" />

</xsl:template>


</xsl:transform>
