<?xml version="1.0" encoding="iso-8859-1"?>
<!-- $Id: xmi.xsl,v 1.1 2003/04/05 02:27:22 stephens Exp $ -->
<xsl:transform
  xmlns="http://www.w3.org/html"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  version="1.1"
>

<!-- *****************************************x*******************************
  XMI uses "xmi.id" as node id.
  -->

<xsl:key name="xmi.id" match="*" use="@xmi.id" />


<!--
#############################################################################
# Returns a full qualified package name string with a separator
#
-->

<xsl:template name="xmi.package.qualified-1">
  <xsl:param name="node" select="." />
  <xsl:param name="sep"  select="'.'" />

  <xsl:variable name="namespace_id" select="$node/Foundation.Core.ModelElement.namespace/Foundation.Core.Namespace/@xmi.idref" />
  <xsl:variable name="namespace_node" select="key('xmi.id', $namespace_id)" />
  <xsl:variable name="namespace_name" select="$namespace_node/Foundation.Core.ModelElement.name" />

  <!--
  <xsl:message> namespace_id <xsl:value-of select="$namespace_id" />
  </xsl:message>
  <xsl:message> namespace_node <xsl:value-of select="name($namespace_node)" />
  </xsl:message>
  <xsl:message> namespace_name <xsl:value-of select="$namespace_name" />
  </xsl:message>
  -->

  <xsl:if test="string-length($namespace_id)">
    <xsl:if test="name($namespace_node)='Model_Management.Package'">
    <xsl:call-template name="xmi.package.qualified-1">
      <xsl:with-param name="node" select="$namespace_node" />
      <xsl:with-param name="sep" select="$sep" />
    </xsl:call-template>
    <xsl:value-of select="$sep" /><xsl:value-of select="$namespace_name" />
    </xsl:if>
  </xsl:if>

</xsl:template>


<xsl:template name="xmi.package.qualified">
  <xsl:param name="node" select="." />
  <xsl:param name="sep" select="'.'" />

  <xsl:variable name="package">
    <xsl:call-template name="xmi.package.qualified-1">
      <xsl:with-param name="node" select="$node" />
      <xsl:with-param name="sep" select="$sep" />
    </xsl:call-template>
  </xsl:variable>

  <xsl:value-of select="substring($package, string-length($sep) + 1)" />
</xsl:template>



<!-- 
#########################################################################
#  Returns a inherited tagged value for a given node.
#  Follows containment patterns:
#
#  Attribute->
#  Class->
#  Package->
#  Model
  -->

<xsl:template match="Foundation.Core.Attribute" mode="xmi.taggedValue.inherited">
  <xsl:param name="tag" select="'foo'" />

<!--
  <xsl:message>tVi node=<xsl:copy-of select="name(.)" /></xsl:message>
  <xsl:message>tVi tag=<xsl:value-of select="$tag" /></xsl:message>
-->

  <xsl:variable name="tv" select="Foundation.Core.ModelElement.taggedValue/Foundation.Extension_Mechanisms.TaggedValue[Foundation.Extension_Mechanisms.TaggedValue.tag=$tag]" />

<!--
  <xsl:message>tVi tv=<xsl:copy-of select="$tv" /></xsl:message>
-->

  <xsl:choose>
    <xsl:when test="$tv">
      <xsl:value-of select="$tv/Foundation.Extension_Mechanisms.TaggedValue.value" />
    </xsl:when>
    <xsl:otherwise>
      <xsl:apply-templates select="key('xmi.id', Foundation.Core.Feature.owner/Foundation.Core.Classifier/@xmi.idref)" mode="xmi.taggedValue.inherited">
        <xsl:with-param name="tag" select="$tag" />
      </xsl:apply-templates>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>


<xsl:template match="Foundation.Core.Class" mode="xmi.taggedValue.inherited">
  <xsl:param name="tag" select="'foo'" />

<!--
  <xsl:message>tVi node=<xsl:copy-of select="name(.)" /></xsl:message>
  <xsl:message>tVi tag=<xsl:value-of select="$tag" /></xsl:message>
-->

  <xsl:variable name="tv" select="Foundation.Core.ModelElement.taggedValue/Foundation.Extension_Mechanisms.TaggedValue[Foundation.Extension_Mechanisms.TaggedValue.tag=$tag]" />

<!--
  <xsl:message>tVi tv=<xsl:copy-of select="$tv" /></xsl:message>
-->
  <xsl:choose>
    <xsl:when test="$tv">
      <xsl:value-of select="$tv/Foundation.Extension_Mechanisms.TaggedValue.value" />
    </xsl:when>
    <xsl:otherwise>
      <xsl:apply-templates select="key('xmi.id', Foundation.Core.ModelElement.namespace/Foundation.Core.Namespace/@xmi.idref)" mode="xmi.taggedValue.inherited">
        <xsl:with-param name="tag" select="$tag" />
      </xsl:apply-templates>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>


<xsl:template match="Model_Management.Package" mode="xmi.taggedValue.inherited">
  <xsl:param name="tag" select="'foo'" />

<!--
  <xsl:message>tVi node=<xsl:copy-of select="name(.)" /></xsl:message>
  <xsl:message>tVi tag=<xsl:value-of select="$tag" /></xsl:message>
-->

  <xsl:variable name="tv" select="Foundation.Core.ModelElement.taggedValue/Foundation.Extension_Mechanisms.TaggedValue[Foundation.Extension_Mechanisms.TaggedValue.tag=$tag]" />

<!--
  <xsl:message>tVi tv=<xsl:copy-of select="$tv" /></xsl:message>
-->

  <xsl:choose>
    <xsl:when test="$tv">
      <xsl:value-of select="$tv/Foundation.Extension_Mechanisms.TaggedValue.value" />
    </xsl:when>
    <xsl:otherwise>
      <xsl:apply-templates select="key('xmi.id', Foundation.Core.ModelElement.namespace/Foundation.Core.Namespace/@xmi.idref)" mode="xmi.taggedValue.inherited">
        <xsl:with-param name="tag" select="$tag" />
      </xsl:apply-templates>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>


<xsl:template match="Model_Management.Model" mode="xmi.taggedValue.inherited">
  <xsl:param name="tag" select="'foo'" />

<!--
  <xsl:message>tVi node=<xsl:copy-of select="name(.)" /></xsl:message>
  <xsl:message>tVi tag=<xsl:value-of select="$tag" /></xsl:message>
-->

  <xsl:variable name="tv" select="Foundation.Core.ModelElement.taggedValue/Foundation.Extension_Mechanisms.TaggedValue[Foundation.Extension_Mechanisms.TaggedValue.tag=$tag]" />

<!--
  <xsl:message>tVi tv=<xsl:copy-of select="$tv" /></xsl:message>
-->

  <xsl:choose>
    <xsl:when test="$tv">
      <xsl:value-of select="$tv/Foundation.Extension_Mechanisms.TaggedValue.value" />
    </xsl:when>
    <xsl:otherwise></xsl:otherwise>
  </xsl:choose>
  
</xsl:template>

<xsl:template name="xmi.taggedValue.inherited">
  <xsl:param name="node" select="." />
  <xsl:param name="tag" />

<!--
  <xsl:message>tVi node=<xsl:copy-of select="name($node)" /></xsl:message>
  <xsl:message>tVi tag=<xsl:value-of select="$tag" /></xsl:message>
-->

  <xsl:apply-templates select="$node" mode="xmi.taggedValue.inherited">
     <xsl:with-param name="tag" select="$tag" />
  </xsl:apply-templates>

</xsl:template>


<!-- #########################################################################
  Returns a copy of the Multiplicity node for given node.
  -->


<xsl:template match="Foundation.Data_Types.Multiplicity[not(@xmi.idref)]" mode="xmi.multiplicity.range">
  <xsl:apply-templates select="Foundation.Data_Types.Multiplicity.range/Foundation.Data_Types.MultiplicityRange" mode="xmi.multiplicity.range" />
</xsl:template>


<xsl:template match="Foundation.Data_Types.Multiplicity[@xmi.idref]" mode="xmi.multiplicity.range">
  <xsl:for-each select="key('xmi.id', @xmi.idref)">
    <xsl:apply-templates select="Foundation.Data_Types.Multiplicity.range/Foundation.Data_Types.MultiplicityRange" mode="xmi.multiplicity.range" />
  </xsl:for-each>
</xsl:template>

<xsl:template match="Foundation.Data_Types.MultiplicityRange" mode="xmi.multiplicity.range">
  <xsl:value-of select="concat(Foundation.Data_Types.MultiplicityRange.lower, '..', Foundation.Data_Types.MultiplicityRange.upper)" />
</xsl:template>

<xsl:template match="*" mode="xmi.multiplicity.range">
  <xsl:value-of select="'1..1'" />
</xsl:template>


<xsl:template name="xmi.multiplicity.range">
  <xsl:param name="node" select="." />
  <xsl:for-each select="$node">
    <xsl:apply-templates mode="xmi.multiplicity.range" />
  </xsl:for-each>
</xsl:template>


<!-- #########################################################################
  Returns all the Generalization nodes nodes that extend a given node.
  -->

<xsl:template name="xmi.generalizations">
  <xsl:param name="node" select="." />

<!--
  <xsl:copy-of select="key('xmi.id', $node/Foundation.Core.GeneralizableElement.generalization/Foundation.Core.Generalization/@xmi.idref)" />
-->

  <xsl:for-each select="$node/Foundation.Core.GeneralizableElement.generalization/Foundation.Core.Generalization/@xmi.idref" >
    <xsl:copy-of select="key('xmi.id', .)" />
  </xsl:for-each>

</xsl:template>


<!-- #########################################################################
  Returns all the Stereotype nodes nodes that extend a given node.
  -->

<xsl:template name="xmi.stereotypes">
  <xsl:param name="node" select="." />

  <xsl:variable name="id" select="$node/@xmi.id" />

  <xsl:copy-of select="Foundation.Extension_Mechanisms.Stereotype[/Foundation.Extension_Mechanisms.Stereotype.extendedElement/Foundation.Core.ModelElement/@xmi.idref=$id]" />
</xsl:template>


<!-- #########################################################################
  Returns all nodes that have a given Stereotype
  -->

<xsl:template name="xmi.stereotype.extends">
  <xsl:param name="node" select="." />

  <xsl:copy-of select="key('xmi.id', $node/Foundation.Extension_Mechanisms.Stereotype.extendedElement/Foundation.Core.ModelElement/@xmi.idref)" />

</xsl:template>


<!-- #########################################################################
  Returns true if a node has a stereotype of a given name.
  -->

<xsl:template name="stereotyped">
  <xsl:param name="node" select="." />
  <xsl:param name="name" select="'create'" />

  <xsl:variable name="node_stereotypes">
    <xsl:call-template name="xmi.stereotypes">
      <xsl:with-param name="node" select="$node"/>
    </xsl:call-template>
  </xsl:variable>

  <xsl:copy-of select="$node_stereotypes[/Foundation.Core.ModelElement.name=$name]" />

</xsl:template>


<!-- #########################################################################
  Returns all Association nodes associated with a Class node.
  -->

<xsl:template name="xmi.associations_for_node">
  <xsl:param name="node" select="." />

  <xsl:variable name="node_id" select="$node/@xmi.id" />

  <!--
  <xsl:message>node = <xsl:copy-of select="$node"/>
  </xsl:message>
  <xsl:message>node_id = <xsl:value-of select="$node_id"/>
  </xsl:message>
  -->

  <!--
  <xsl:copy-of select="key('xmi.associations_for_node', $node_id)" />
  -->

  <xsl:copy-of select="//Foundation.Core.Association[Foundation.Core.Association.connection/Foundation.Core.AssociationEnd/Foundation.Core.AssociationEnd.type/Foundation.Core.Classifier/@xmi.idref=$node_id]" />

</xsl:template>


<!-- #########################################################################
  Returns all AssociationEnd node associated with a Class node that are opposite
  the end pointing to the Class node.
  -->


<xsl:template name="xmi.association_ends_opposite_node">
  <xsl:param name="node" select="." />

  <xsl:variable name="node_id" select="$node/@xmi.id" />

<!--
  <xsl:message>node_id = <xsl:value-of select="$node_id" />
</xsl:message>
-->

  <xsl:copy-of select="//Foundation.Core.Association[Foundation.Core.Association.connection/Foundation.Core.AssociationEnd/Foundation.Core.AssociationEnd.type/Foundation.Core.Classifier/@xmi.idref=$node_id]/Foundation.Core.Association.connection/Foundation.Core.AssociationEnd[Foundation.Core.AssociationEnd.type/Foundation.Core.Classifier/@xmi.idref!=$node_id]" />

</xsl:template>



<!-- #########################################################################
  Test


<xsl:template match="Foundation.Core.Class">

  <xsl:variable name="class_name" select="Foundation.Core.ModelElement.name" />
  <xsl:variable name="package">
    <xsl:call-template name="java_package">
      <xsl:with-param name="node" select="." />
    </xsl:call-template>
  </xsl:variable>

  <xsl:text>package </xsl:text><xsl:value-of select="$package" /><xsl:text>
  </xsl:text>

  <xsl:text>class </xsl:text><xsl:value-of select="$class_name" /><xsl:text>
  </xsl:text>

</xsl:template>

<xsl:template match="/">
  <xsl:apply-templates select="Foundation.Core.Class" />
</xsl:template>

-->

</xsl:transform>
