package UML::MetaModel::Foundation::Core::Classifier;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::Namespace UML::MetaModel::Foundation::Core::GeneralizableElement);

sub __model_name { 'Foundation::Core::Classifier' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaClassifier { 1 }

sub isaFoundation__Core__Classifier { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::Classifier')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::Classifier': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Namespace::__initialize;
  $self->UML::MetaModel::Foundation::Core::GeneralizableElement::__initialize;

# AssociationEnd 0x86dc244 name = type_, type = Foundation::Core::Parameter multiplicity = *
$self->{'type_'} = undef unless exists $self->{'type_'};
# AssociationEnd 0x870ef54 name = feature, type = Foundation::Core::Feature multiplicity = *
$self->{'feature'} = undef unless exists $self->{'feature'};
# AssociationEnd 0x86ba824 name = typedFeature, type = Foundation::Core::StructuralFeature multiplicity = *
$self->{'typedFeature'} = undef unless exists $self->{'typedFeature'};
# AssociationEnd 0x8707ca0 name = powertypeRange, type = Foundation::Core::Generalization multiplicity = *
$self->{'powertypeRange'} = undef unless exists $self->{'powertypeRange'};
# AssociationEnd 0x872daf4 name = association, type = Foundation::Core::AssociationEnd multiplicity = *
$self->{'association'} = undef unless exists $self->{'association'};
# AssociationEnd 0x86ba364 name = specifiedEnd, type = Foundation::Core::AssociationEnd multiplicity = *
$self->{'specifiedEnd'} = undef unless exists $self->{'specifiedEnd'};

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Namespace::__initialize_associations;
  $self->UML::MetaModel::Foundation::Core::GeneralizableElement::__initialize_associations;

# AssociationEnd 0x86dc244 name = type_, type = Foundation::Core::Parameter multiplicity = *

	      if ( defined $self->{'type_'} && @{$self->{'type_'}}) {
		my $x = $self->{'type_'};
		$self->{'type_'} = [ ];
		$self->add_type_(@$x);
	      }
	    
# AssociationEnd 0x870ef54 name = feature, type = Foundation::Core::Feature multiplicity = *

	      if ( defined $self->{'feature'} && @{$self->{'feature'}}) {
		my $x = $self->{'feature'};
		$self->{'feature'} = [ ];
		$self->add_feature(@$x);
	      }
	    
# AssociationEnd 0x86ba824 name = typedFeature, type = Foundation::Core::StructuralFeature multiplicity = *

	      if ( defined $self->{'typedFeature'} && @{$self->{'typedFeature'}}) {
		my $x = $self->{'typedFeature'};
		$self->{'typedFeature'} = [ ];
		$self->add_typedFeature(@$x);
	      }
	    
# AssociationEnd 0x8707ca0 name = powertypeRange, type = Foundation::Core::Generalization multiplicity = *

	      if ( defined $self->{'powertypeRange'} && @{$self->{'powertypeRange'}}) {
		my $x = $self->{'powertypeRange'};
		$self->{'powertypeRange'} = [ ];
		$self->add_powertypeRange(@$x);
	      }
	    
# AssociationEnd 0x872daf4 name = association, type = Foundation::Core::AssociationEnd multiplicity = *

	      if ( defined $self->{'association'} && @{$self->{'association'}}) {
		my $x = $self->{'association'};
		$self->{'association'} = [ ];
		$self->add_association(@$x);
	      }
	    
# AssociationEnd 0x86ba364 name = specifiedEnd, type = Foundation::Core::AssociationEnd multiplicity = *

	      if ( defined $self->{'specifiedEnd'} && @{$self->{'specifiedEnd'}}) {
		my $x = $self->{'specifiedEnd'};
		$self->{'specifiedEnd'} = [ ];
		$self->add_specifiedEnd(@$x);
	      }
	    

  $self;
}

# AssociationEnd 0x86dc244 name = type_, type = Foundation::Core::Parameter multiplicity = *

	      sub type_ {
		my ($self) = @_;
		
		my $x = $self->{'type_'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_type_ {
		my ($self, @new) = @_;
		
		$self->clear_type_;
		$self->add_type_(@new);
	      }
	      sub add_type_ {
		my ($self, @new) = @_;
		
		my $x = $self->{'type_'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Parameter')
    ->__typecheck($new, 'type_');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x86ba764 name = type, type = Foundation::Core::Classifier, multiplicity = 1

	  $old->set_type($self) if $old;
	  $new->set_type($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_type_ {
		my ($self, @new) = @_;

		my $x = $self->{'type_'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Parameter')
    ->__typecheck($old, 'type_');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x86ba764 name = type, type = Foundation::Core::Classifier, multiplicity = 1

	  $old->set_type($self) if $old;
	  $new->set_type($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_type_ {
		my ($self) = @_;

		my $x = $self->{'type_'} ||= [ ];
		my $new; # Place holder

		$self->{'type_'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x86ba764 name = type, type = Foundation::Core::Classifier, multiplicity = 1

	  $old->set_type($self) if $old;
	  $new->set_type($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x870ef54 name = feature, type = Foundation::Core::Feature multiplicity = *

	      sub feature {
		my ($self) = @_;
		
		my $x = $self->{'feature'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_feature {
		my ($self, @new) = @_;
		
		$self->clear_feature;
		$self->add_feature(@new);
	      }
	      sub add_feature {
		my ($self, @new) = @_;
		
		my $x = $self->{'feature'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Feature')
    ->__typecheck($new, 'feature');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x875aa94 name = owner, type = Foundation::Core::Classifier, multiplicity = 0..1

	  $old->set_owner($self) if $old;
	  $new->set_owner($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_feature {
		my ($self, @new) = @_;

		my $x = $self->{'feature'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Feature')
    ->__typecheck($old, 'feature');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x875aa94 name = owner, type = Foundation::Core::Classifier, multiplicity = 0..1

	  $old->set_owner($self) if $old;
	  $new->set_owner($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_feature {
		my ($self) = @_;

		my $x = $self->{'feature'} ||= [ ];
		my $new; # Place holder

		$self->{'feature'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x875aa94 name = owner, type = Foundation::Core::Classifier, multiplicity = 0..1

	  $old->set_owner($self) if $old;
	  $new->set_owner($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x86ba824 name = typedFeature, type = Foundation::Core::StructuralFeature multiplicity = *

	      sub typedFeature {
		my ($self) = @_;
		
		my $x = $self->{'typedFeature'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_typedFeature {
		my ($self, @new) = @_;
		
		$self->clear_typedFeature;
		$self->add_typedFeature(@new);
	      }
	      sub add_typedFeature {
		my ($self, @new) = @_;
		
		my $x = $self->{'typedFeature'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::StructuralFeature')
    ->__typecheck($new, 'typedFeature');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x875adc4 name = type, type = Foundation::Core::Classifier, multiplicity = 1

	  $old->set_type($self) if $old;
	  $new->set_type($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_typedFeature {
		my ($self, @new) = @_;

		my $x = $self->{'typedFeature'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::StructuralFeature')
    ->__typecheck($old, 'typedFeature');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x875adc4 name = type, type = Foundation::Core::Classifier, multiplicity = 1

	  $old->set_type($self) if $old;
	  $new->set_type($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_typedFeature {
		my ($self) = @_;

		my $x = $self->{'typedFeature'} ||= [ ];
		my $new; # Place holder

		$self->{'typedFeature'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x875adc4 name = type, type = Foundation::Core::Classifier, multiplicity = 1

	  $old->set_type($self) if $old;
	  $new->set_type($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x8707ca0 name = powertypeRange, type = Foundation::Core::Generalization multiplicity = *

	      sub powertypeRange {
		my ($self) = @_;
		
		my $x = $self->{'powertypeRange'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_powertypeRange {
		my ($self, @new) = @_;
		
		$self->clear_powertypeRange;
		$self->add_powertypeRange(@new);
	      }
	      sub add_powertypeRange {
		my ($self, @new) = @_;
		
		my $x = $self->{'powertypeRange'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Generalization')
    ->__typecheck($new, 'powertypeRange');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x868c9b4 name = powertype, type = Foundation::Core::Classifier, multiplicity = 0..1

	  $old->set_powertype($self) if $old;
	  $new->set_powertype($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_powertypeRange {
		my ($self, @new) = @_;

		my $x = $self->{'powertypeRange'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Generalization')
    ->__typecheck($old, 'powertypeRange');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x868c9b4 name = powertype, type = Foundation::Core::Classifier, multiplicity = 0..1

	  $old->set_powertype($self) if $old;
	  $new->set_powertype($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_powertypeRange {
		my ($self) = @_;

		my $x = $self->{'powertypeRange'} ||= [ ];
		my $new; # Place holder

		$self->{'powertypeRange'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x868c9b4 name = powertype, type = Foundation::Core::Classifier, multiplicity = 0..1

	  $old->set_powertype($self) if $old;
	  $new->set_powertype($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x872daf4 name = association, type = Foundation::Core::AssociationEnd multiplicity = *

	      sub association {
		my ($self) = @_;
		
		my $x = $self->{'association'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_association {
		my ($self, @new) = @_;
		
		$self->clear_association;
		$self->add_association(@new);
	      }
	      sub add_association {
		my ($self, @new) = @_;
		
		my $x = $self->{'association'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::AssociationEnd')
    ->__typecheck($new, 'association');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x870d388 name = participant, type = Foundation::Core::Classifier, multiplicity = 1

	  $old->set_participant($self) if $old;
	  $new->set_participant($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_association {
		my ($self, @new) = @_;

		my $x = $self->{'association'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::AssociationEnd')
    ->__typecheck($old, 'association');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x870d388 name = participant, type = Foundation::Core::Classifier, multiplicity = 1

	  $old->set_participant($self) if $old;
	  $new->set_participant($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_association {
		my ($self) = @_;

		my $x = $self->{'association'} ||= [ ];
		my $new; # Place holder

		$self->{'association'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x870d388 name = participant, type = Foundation::Core::Classifier, multiplicity = 1

	  $old->set_participant($self) if $old;
	  $new->set_participant($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x86ba364 name = specifiedEnd, type = Foundation::Core::AssociationEnd multiplicity = *

	      sub specifiedEnd {
		my ($self) = @_;
		
		my $x = $self->{'specifiedEnd'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_specifiedEnd {
		my ($self, @new) = @_;
		
		$self->clear_specifiedEnd;
		$self->add_specifiedEnd(@new);
	      }
	      sub add_specifiedEnd {
		my ($self, @new) = @_;
		
		my $x = $self->{'specifiedEnd'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::AssociationEnd')
    ->__typecheck($new, 'specifiedEnd');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x8737228 name = specification, type = Foundation::Core::Classifier, multiplicity = *

	  $old->remove_specification($self) if $old;
	  $new->add_specification($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_specifiedEnd {
		my ($self, @new) = @_;

		my $x = $self->{'specifiedEnd'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::AssociationEnd')
    ->__typecheck($old, 'specifiedEnd');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x8737228 name = specification, type = Foundation::Core::Classifier, multiplicity = *

	  $old->remove_specification($self) if $old;
	  $new->add_specification($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_specifiedEnd {
		my ($self) = @_;

		my $x = $self->{'specifiedEnd'} ||= [ ];
		my $new; # Place holder

		$self->{'specifiedEnd'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x8737228 name = specification, type = Foundation::Core::Classifier, multiplicity = *

	  $old->remove_specification($self) if $old;
	  $new->add_specification($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    


1;

