package UML::MetaModel::Foundation::Core::GeneralizableElement;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::ModelElement);

sub __model_name { 'Foundation::Core::GeneralizableElement' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaGeneralizableElement { 1 }

sub isaFoundation__Core__GeneralizableElement { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::GeneralizableElement')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::GeneralizableElement': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::ModelElement::__initialize;

# AssociationEnd 0x8707a90 name = generalization, type = Foundation::Core::Generalization multiplicity = *
$self->{'generalization'} = undef unless exists $self->{'generalization'};
# Attribute 0x8673504 name = isRoot, type = Foundation::Data_Types::Boolean, multiplicity = 1

	  if ( exists $self->{'isRoot'} ) {
	    my $x = $self->{'isRoot'};
	    $self->{'isRoot'} = undef;
	    $self->set_isRoot($x);
	  } else {
	    ;
	  }
	
# Attribute 0x86735f4 name = isLeaf, type = Foundation::Data_Types::Boolean, multiplicity = 1

	  if ( exists $self->{'isLeaf'} ) {
	    my $x = $self->{'isLeaf'};
	    $self->{'isLeaf'} = undef;
	    $self->set_isLeaf($x);
	  } else {
	    ;
	  }
	
# Attribute 0x8673708 name = isAbstract, type = Foundation::Data_Types::Boolean, multiplicity = 1

	  if ( exists $self->{'isAbstract'} ) {
	    my $x = $self->{'isAbstract'};
	    $self->{'isAbstract'} = undef;
	    $self->set_isAbstract($x);
	  } else {
	    ;
	  }
	

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::ModelElement::__initialize_associations;

# AssociationEnd 0x8707a90 name = generalization, type = Foundation::Core::Generalization multiplicity = *

	      if ( defined $self->{'generalization'} && @{$self->{'generalization'}}) {
		my $x = $self->{'generalization'};
		$self->{'generalization'} = [ ];
		$self->add_generalization(@$x);
	      }
	    

  $self;
}

# AssociationEnd 0x8707a90 name = generalization, type = Foundation::Core::Generalization multiplicity = *

	      sub generalization {
		my ($self) = @_;
		
		my $x = $self->{'generalization'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_generalization {
		my ($self, @new) = @_;
		
		$self->clear_generalization;
		$self->add_generalization(@new);
	      }
	      sub add_generalization {
		my ($self, @new) = @_;
		
		my $x = $self->{'generalization'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Generalization')
    ->__typecheck($new, 'generalization');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x872d4d4 name = child, type = Foundation::Core::GeneralizableElement, multiplicity = *

	  $old->remove_child($self) if $old;
	  $new->add_child($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_generalization {
		my ($self, @new) = @_;

		my $x = $self->{'generalization'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Generalization')
    ->__typecheck($old, 'generalization');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x872d4d4 name = child, type = Foundation::Core::GeneralizableElement, multiplicity = *

	  $old->remove_child($self) if $old;
	  $new->add_child($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_generalization {
		my ($self) = @_;

		my $x = $self->{'generalization'} ||= [ ];
		my $new; # Place holder

		$self->{'generalization'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x872d4d4 name = child, type = Foundation::Core::GeneralizableElement, multiplicity = *

	  $old->remove_child($self) if $old;
	  $new->add_child($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# Attribute 0x8673504 name = isRoot, type = Foundation::Data_Types::Boolean, multiplicity = 1

	  sub isRoot {
	    my ($self) = @_;

	    $self->{'isRoot'};
	  }
	  sub set_isRoot {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::Boolean')
    ->__typecheck($new, 'isRoot');
  ;

	    $self->{'isRoot'} = $new;

	    $self;
	  }
	
# Attribute 0x86735f4 name = isLeaf, type = Foundation::Data_Types::Boolean, multiplicity = 1

	  sub isLeaf {
	    my ($self) = @_;

	    $self->{'isLeaf'};
	  }
	  sub set_isLeaf {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::Boolean')
    ->__typecheck($new, 'isLeaf');
  ;

	    $self->{'isLeaf'} = $new;

	    $self;
	  }
	
# Attribute 0x8673708 name = isAbstract, type = Foundation::Data_Types::Boolean, multiplicity = 1

	  sub isAbstract {
	    my ($self) = @_;

	    $self->{'isAbstract'};
	  }
	  sub set_isAbstract {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::Boolean')
    ->__typecheck($new, 'isAbstract');
  ;

	    $self->{'isAbstract'} = $new;

	    $self;
	  }
	


1;

