package UML::MetaModel::Foundation::Core::Generalization;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::Relationship);

sub __model_name { 'Foundation::Core::Generalization' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaGeneralization { 1 }

sub isaFoundation__Core__Generalization { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::Generalization')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::Generalization': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Relationship::__initialize;

# AssociationEnd 0x872d4d4 name = child, type = Foundation::Core::GeneralizableElement multiplicity = *
$self->{'child'} = undef unless exists $self->{'child'};
# AssociationEnd 0x875f140 name = parent, type = Foundation::Core::ModelElement multiplicity = *
$self->{'parent'} = undef unless exists $self->{'parent'};
# AssociationEnd 0x868c9b4 name = powertype, type = Foundation::Core::Classifier multiplicity = 0..1
$self->{'powertype'} = undef unless exists $self->{'powertype'};

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Relationship::__initialize_associations;

# AssociationEnd 0x872d4d4 name = child, type = Foundation::Core::GeneralizableElement multiplicity = *

	      if ( defined $self->{'child'} && @{$self->{'child'}}) {
		my $x = $self->{'child'};
		$self->{'child'} = [ ];
		$self->add_child(@$x);
	      }
	    
# AssociationEnd 0x875f140 name = parent, type = Foundation::Core::ModelElement multiplicity = *

	      if ( defined $self->{'parent'} && @{$self->{'parent'}}) {
		my $x = $self->{'parent'};
		$self->{'parent'} = [ ];
		$self->add_parent(@$x);
	      }
	    
# AssociationEnd 0x868c9b4 name = powertype, type = Foundation::Core::Classifier multiplicity = 0..1

	      if ( defined $self->{'powertype'} ) {
		my $x = $self->{'powertype'};
		$self->{'powertype'} = undef;
		$self->set_powertype($x);
	      }
	    

  $self;
}

# AssociationEnd 0x872d4d4 name = child, type = Foundation::Core::GeneralizableElement multiplicity = *

	      sub child {
		my ($self) = @_;
		
		my $x = $self->{'child'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_child {
		my ($self, @new) = @_;
		
		$self->clear_child;
		$self->add_child(@new);
	      }
	      sub add_child {
		my ($self, @new) = @_;
		
		my $x = $self->{'child'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::GeneralizableElement')
    ->__typecheck($new, 'child');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x8707a90 name = generalization, type = Foundation::Core::Generalization, multiplicity = *

	  $old->remove_generalization($self) if $old;
	  $new->add_generalization($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_child {
		my ($self, @new) = @_;

		my $x = $self->{'child'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::GeneralizableElement')
    ->__typecheck($old, 'child');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x8707a90 name = generalization, type = Foundation::Core::Generalization, multiplicity = *

	  $old->remove_generalization($self) if $old;
	  $new->add_generalization($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_child {
		my ($self) = @_;

		my $x = $self->{'child'} ||= [ ];
		my $new; # Place holder

		$self->{'child'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x8707a90 name = generalization, type = Foundation::Core::Generalization, multiplicity = *

	  $old->remove_generalization($self) if $old;
	  $new->add_generalization($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x875f140 name = parent, type = Foundation::Core::ModelElement multiplicity = *

	      sub parent {
		my ($self) = @_;
		
		my $x = $self->{'parent'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_parent {
		my ($self, @new) = @_;
		
		$self->clear_parent;
		$self->add_parent(@new);
	      }
	      sub add_parent {
		my ($self, @new) = @_;
		
		my $x = $self->{'parent'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($new, 'parent');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x8707b44 name = specialization, type = Foundation::Core::Generalization, multiplicity = *

	  $old->remove_specialization($self) if $old;
	  $new->add_specialization($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_parent {
		my ($self, @new) = @_;

		my $x = $self->{'parent'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($old, 'parent');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x8707b44 name = specialization, type = Foundation::Core::Generalization, multiplicity = *

	  $old->remove_specialization($self) if $old;
	  $new->add_specialization($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_parent {
		my ($self) = @_;

		my $x = $self->{'parent'} ||= [ ];
		my $new; # Place holder

		$self->{'parent'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x8707b44 name = specialization, type = Foundation::Core::Generalization, multiplicity = *

	  $old->remove_specialization($self) if $old;
	  $new->add_specialization($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x868c9b4 name = powertype, type = Foundation::Core::Classifier multiplicity = 0..1

	      sub powertype {
		my ($self) = @_;
		
		$self->{'powertype'};
	      }
	      sub set_powertype {
		my ($self, $new) = @_;

		no warnings;

		my $old;
		if ( ($old = $self->{'powertype'}) ne $new ) { # Recursion lock
		  ! defined($new) || 
    $self->__autouse('UML::MetaModel::Foundation::Core::Classifier')
    ->__typecheck($new, 'powertype');
  ;
		  $self->{'powertype'} = $new;        # Recursion lock
		  # AssociationEnd 0x8707ca0 name = powertypeRange, type = Foundation::Core::Generalization, multiplicity = *

	  $old->remove_powertypeRange($self) if $old;
	  $new->add_powertypeRange($self) if $new;
	;
		}

		$self;
	      }
	    


1;

