package UML::MetaModel::Foundation::Core::Operation;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::BehavioralFeature);

sub __model_name { 'Foundation::Core::Operation' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaOperation { 1 }

sub isaFoundation__Core__Operation { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::Operation')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::Operation': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::BehavioralFeature::__initialize;

# AssociationEnd 0x872da70 name = specification_, type = Foundation::Core::Method multiplicity = *
$self->{'specification_'} = undef unless exists $self->{'specification_'};
# Attribute 0x8704318 name = concurrency, type = Foundation::Data_Types::CallConcurrencyKind, multiplicity = 1

	  if ( exists $self->{'concurrency'} ) {
	    my $x = $self->{'concurrency'};
	    $self->{'concurrency'} = undef;
	    $self->set_concurrency($x);
	  } else {
	    ;
	  }
	
# Attribute 0x8704444 name = isRoot, type = Foundation::Data_Types::Boolean, multiplicity = 1

	  if ( exists $self->{'isRoot'} ) {
	    my $x = $self->{'isRoot'};
	    $self->{'isRoot'} = undef;
	    $self->set_isRoot($x);
	  } else {
	    ;
	  }
	
# Attribute 0x8704540 name = isLeaf, type = Foundation::Data_Types::Boolean, multiplicity = 1

	  if ( exists $self->{'isLeaf'} ) {
	    my $x = $self->{'isLeaf'};
	    $self->{'isLeaf'} = undef;
	    $self->set_isLeaf($x);
	  } else {
	    ;
	  }
	
# Attribute 0x8704624 name = isAbstract, type = Foundation::Data_Types::Boolean, multiplicity = 1

	  if ( exists $self->{'isAbstract'} ) {
	    my $x = $self->{'isAbstract'};
	    $self->{'isAbstract'} = undef;
	    $self->set_isAbstract($x);
	  } else {
	    ;
	  }
	

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::BehavioralFeature::__initialize_associations;

# AssociationEnd 0x872da70 name = specification_, type = Foundation::Core::Method multiplicity = *

	      if ( defined $self->{'specification_'} && @{$self->{'specification_'}}) {
		my $x = $self->{'specification_'};
		$self->{'specification_'} = [ ];
		$self->add_specification_(@$x);
	      }
	    

  $self;
}

# AssociationEnd 0x872da70 name = specification_, type = Foundation::Core::Method multiplicity = *

	      sub specification_ {
		my ($self) = @_;
		
		my $x = $self->{'specification_'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_specification_ {
		my ($self, @new) = @_;
		
		$self->clear_specification_;
		$self->add_specification_(@new);
	      }
	      sub add_specification_ {
		my ($self, @new) = @_;
		
		my $x = $self->{'specification_'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Method')
    ->__typecheck($new, 'specification_');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x86ba8f0 name = specification, type = Foundation::Core::Operation, multiplicity = 1

	  $old->set_specification($self) if $old;
	  $new->set_specification($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_specification_ {
		my ($self, @new) = @_;

		my $x = $self->{'specification_'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Method')
    ->__typecheck($old, 'specification_');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x86ba8f0 name = specification, type = Foundation::Core::Operation, multiplicity = 1

	  $old->set_specification($self) if $old;
	  $new->set_specification($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_specification_ {
		my ($self) = @_;

		my $x = $self->{'specification_'} ||= [ ];
		my $new; # Place holder

		$self->{'specification_'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x86ba8f0 name = specification, type = Foundation::Core::Operation, multiplicity = 1

	  $old->set_specification($self) if $old;
	  $new->set_specification($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# Attribute 0x8704318 name = concurrency, type = Foundation::Data_Types::CallConcurrencyKind, multiplicity = 1

	  sub concurrency {
	    my ($self) = @_;

	    $self->{'concurrency'};
	  }
	  sub set_concurrency {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::CallConcurrencyKind')
    ->__typecheck($new, 'concurrency');
  ;

	    $self->{'concurrency'} = $new;

	    $self;
	  }
	
# Attribute 0x8704444 name = isRoot, type = Foundation::Data_Types::Boolean, multiplicity = 1

	  sub isRoot {
	    my ($self) = @_;

	    $self->{'isRoot'};
	  }
	  sub set_isRoot {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::Boolean')
    ->__typecheck($new, 'isRoot');
  ;

	    $self->{'isRoot'} = $new;

	    $self;
	  }
	
# Attribute 0x8704540 name = isLeaf, type = Foundation::Data_Types::Boolean, multiplicity = 1

	  sub isLeaf {
	    my ($self) = @_;

	    $self->{'isLeaf'};
	  }
	  sub set_isLeaf {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::Boolean')
    ->__typecheck($new, 'isLeaf');
  ;

	    $self->{'isLeaf'} = $new;

	    $self;
	  }
	
# Attribute 0x8704624 name = isAbstract, type = Foundation::Data_Types::Boolean, multiplicity = 1

	  sub isAbstract {
	    my ($self) = @_;

	    $self->{'isAbstract'};
	  }
	  sub set_isAbstract {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::Boolean')
    ->__typecheck($new, 'isAbstract');
  ;

	    $self->{'isAbstract'} = $new;

	    $self;
	  }
	


1;

