package UML::MetaModel::Foundation::Extension_Mechanisms::Stereotype;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::GeneralizableElement);

sub __model_name { 'Foundation::Extension_Mechanisms::Stereotype' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaStereotype { 1 }

sub isaFoundation__Extension_Mechanisms__Stereotype { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Extension_Mechanisms::Stereotype')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Extension_Mechanisms::Stereotype': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::GeneralizableElement::__initialize;

# AssociationEnd 0x86ca758 name = stereotypeConstraint, type = Foundation::Core::Constraint multiplicity = *
$self->{'stereotypeConstraint'} = undef unless exists $self->{'stereotypeConstraint'};
# AssociationEnd 0x872ba9c name = definedTag, type = Foundation::Extension_Mechanisms::TagDefinition multiplicity = *
$self->{'definedTag'} = undef unless exists $self->{'definedTag'};
# Attribute 0x87349f8 name = icon, type = Foundation::Data_Types::Geometry, multiplicity = 1

	  if ( exists $self->{'icon'} ) {
	    my $x = $self->{'icon'};
	    $self->{'icon'} = undef;
	    $self->set_icon($x);
	  } else {
	    ;
	  }
	
# Attribute 0x8734ac4 name = baseClass, type = Foundation::Data_Types::Name, multiplicity = *
$self->{'baseClass'} = undef unless exists $self->{'baseClass'};

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::GeneralizableElement::__initialize_associations;

# AssociationEnd 0x86ca758 name = stereotypeConstraint, type = Foundation::Core::Constraint multiplicity = *

	      if ( defined $self->{'stereotypeConstraint'} && @{$self->{'stereotypeConstraint'}}) {
		my $x = $self->{'stereotypeConstraint'};
		$self->{'stereotypeConstraint'} = [ ];
		$self->add_stereotypeConstraint(@$x);
	      }
	    
# AssociationEnd 0x872ba9c name = definedTag, type = Foundation::Extension_Mechanisms::TagDefinition multiplicity = *

	      if ( defined $self->{'definedTag'} && @{$self->{'definedTag'}}) {
		my $x = $self->{'definedTag'};
		$self->{'definedTag'} = [ ];
		$self->add_definedTag(@$x);
	      }
	    

  $self;
}

# AssociationEnd 0x86ca758 name = stereotypeConstraint, type = Foundation::Core::Constraint multiplicity = *

	      sub stereotypeConstraint {
		my ($self) = @_;
		
		my $x = $self->{'stereotypeConstraint'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_stereotypeConstraint {
		my ($self, @new) = @_;
		
		$self->clear_stereotypeConstraint;
		$self->add_stereotypeConstraint(@new);
	      }
	      sub add_stereotypeConstraint {
		my ($self, @new) = @_;
		
		my $x = $self->{'stereotypeConstraint'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Constraint')
    ->__typecheck($new, 'stereotypeConstraint');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x86bb9c8 name = constrainedStereotype, type = Foundation::Extension_Mechanisms::Stereotype, multiplicity = 0..1

	  $old->set_constrainedStereotype($self) if $old;
	  $new->set_constrainedStereotype($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_stereotypeConstraint {
		my ($self, @new) = @_;

		my $x = $self->{'stereotypeConstraint'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Constraint')
    ->__typecheck($old, 'stereotypeConstraint');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x86bb9c8 name = constrainedStereotype, type = Foundation::Extension_Mechanisms::Stereotype, multiplicity = 0..1

	  $old->set_constrainedStereotype($self) if $old;
	  $new->set_constrainedStereotype($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_stereotypeConstraint {
		my ($self) = @_;

		my $x = $self->{'stereotypeConstraint'} ||= [ ];
		my $new; # Place holder

		$self->{'stereotypeConstraint'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x86bb9c8 name = constrainedStereotype, type = Foundation::Extension_Mechanisms::Stereotype, multiplicity = 0..1

	  $old->set_constrainedStereotype($self) if $old;
	  $new->set_constrainedStereotype($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x872ba9c name = definedTag, type = Foundation::Extension_Mechanisms::TagDefinition multiplicity = *

	      sub definedTag {
		my ($self) = @_;
		
		my $x = $self->{'definedTag'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_definedTag {
		my ($self, @new) = @_;
		
		$self->clear_definedTag;
		$self->add_definedTag(@new);
	      }
	      sub add_definedTag {
		my ($self, @new) = @_;
		
		my $x = $self->{'definedTag'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Extension_Mechanisms::TagDefinition')
    ->__typecheck($new, 'definedTag');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x86ccab0 name = owner, type = Foundation::Extension_Mechanisms::Stereotype, multiplicity = 0..1

	  $old->set_owner($self) if $old;
	  $new->set_owner($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_definedTag {
		my ($self, @new) = @_;

		my $x = $self->{'definedTag'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Extension_Mechanisms::TagDefinition')
    ->__typecheck($old, 'definedTag');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x86ccab0 name = owner, type = Foundation::Extension_Mechanisms::Stereotype, multiplicity = 0..1

	  $old->set_owner($self) if $old;
	  $new->set_owner($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_definedTag {
		my ($self) = @_;

		my $x = $self->{'definedTag'} ||= [ ];
		my $new; # Place holder

		$self->{'definedTag'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x86ccab0 name = owner, type = Foundation::Extension_Mechanisms::Stereotype, multiplicity = 0..1

	  $old->set_owner($self) if $old;
	  $new->set_owner($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# Attribute 0x87349f8 name = icon, type = Foundation::Data_Types::Geometry, multiplicity = 1

	  sub icon {
	    my ($self) = @_;

	    $self->{'icon'};
	  }
	  sub set_icon {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::Geometry')
    ->__typecheck($new, 'icon');
  ;

	    $self->{'icon'} = $new;

	    $self;
	  }
	
# Attribute 0x8734ac4 name = baseClass, type = Foundation::Data_Types::Name, multiplicity = *

	  sub baseClass {
	    my ($self) = @_;
	    
	    my $x = $self->{'baseClass'};
	    wantarray ? @{$x} : $x;
	  }
	  sub set_baseClass {
	    my ($self, @new) = @_;
	    
	    for my $new ( @new ) { 
	      
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::Name')
    ->__typecheck($new, 'baseClass');
  ;
	    }
	    
	    $self->{'baseClass'} = [ @new ];
	    
	    $self;
	  }
	  sub add_baseClass {
	    my ($self, @new) = @_;
	    
	    for my $new ( @new ) { 
	      
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::Name')
    ->__typecheck($new, 'baseClass');
  ;
	    }
	    push(@{$self->{'baseClass'} ||= [ ]}, @new);
	    
	    $self;
	  }
	  sub remove_baseClass {
	    my ($self, @new) = @_;
	    for my $new ( @new ) { 
	      
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::Name')
    ->__typecheck($new, 'baseClass');
  ;
	    }
	    my $x = $self->{'baseClass'} ||= [ ];
	    for my $new ( @new ) {
	      @$x = grep($_ ne $new, @$x);
	    }
	    
	    $self;
	  }
	


1;

